(*
 * Partiel 2008 01
 * Question 7
 *)
    
type asm =
    Nop
  | PUSH of int
  | POPA
  | POPB
  | PUSHA
  | PUSHB
  | ADD
  | SUB
  | MUL
  | JMP of string
  | BEQ of int * string
  | BNZ of string
  | LAB of string
  | OUT
  | STOP

type register = {
  mutable a : int;
  mutable b : int;
}

(* un exemple de programme *)    
let prg = [|
  PUSH 5;
  PUSH 1;
  POPB;
  LAB "boucle";
  POPA;
  PUSHA;
  PUSHB;
  MUL;
  POPB;
  PUSH 1;
  PUSHA;
  SUB;
  BNZ "boucle";
  PUSHB;
  OUT;
  STOP
|]

let eval instTab =
  let pc = ref 0 in
  let env = Hashtbl.create 17 in
  let stack = Stack.create () in
  let run = ref true in
  let reg = { a = 0; b = 0; } in
  let next () = pc := !pc + 1 in
    while !run do
      match instTab.(!pc) with
	  Nop -> next ()
	| PUSH i -> (Stack.push i stack; next ())
	| POPA -> (reg.a <- Stack.pop stack; next ())
	| POPB -> (reg.b <- Stack.pop stack; next ())
	| PUSHA -> (Stack.push reg.a stack; next ())
	| PUSHB -> (Stack.push reg.b stack; next ())
	| ADD ->
	    let (x,y) = (Stack.pop stack, Stack.pop stack) in
	      (Stack.push (x+y) stack; next ())
	| SUB ->
	    let x = Stack.pop stack in
	    let y = Stack.pop stack in
	      (Stack.push (x-y) stack; next ())
	| MUL ->
	    let (x,y) = (Stack.pop stack, Stack.pop stack) in
	      (Stack.push (x*y) stack; next ())
	| JMP s ->
	    pc := Hashtbl.find env s
	| BEQ(i,s) ->
	    if i = Stack.top stack then pc := Hashtbl.find env s
	    else next ()
	| BNZ s ->
	    if Stack.top stack <> 0 then pc := Hashtbl.find env s
	    else next ()
	| LAB s ->
	    begin
	      next ();
	      Hashtbl.add env s !pc
	    end
	| OUT ->
	    begin
	      Printf.printf "%d\n" (Stack.pop stack);
	      next ()
	    end
	| STOP -> run := false
    done
