(*
 * Test question 4
 *)

open Question4

(* Partie test: ne pas modifier *)
let _ =
  let q = Queue.create () in
  let anonfun s =
    try
      let x = int_of_string s in
	Queue.add x q
    with
	_ -> ()
  in
  let get_liste () =
    List.rev (Queue.fold (fun x y -> y::x) [] q)
  in
  let print_int_list l =
    Printf.printf "[ ";
    List.iter (Printf.printf "%d; ") l;
    Printf.printf "]\n"
  in
  let print_str_list l =
    Printf.printf "[ ";
    List.iter (Printf.printf "\"%s\"; ") l;
    Printf.printf "]\n"
  in
  let print_bilist =
    let rec print_a = function
	Nil_a -> ()
      | B_a (a,t) ->
	  begin
	    Printf.printf "B_a %d; " a;
	    print_b t
	  end
    and print_b = function
	Nil_b -> ()
      | B_b(b,t) ->
	  begin
	    Printf.printf "B_b \"%s\"; " b;
	    print_a t
	  end
    in
      function
	  A a -> (Printf.printf "[ "; print_a a; Printf.printf "]\n")
	| B b -> (Printf.printf "[ "; print_b b; Printf.printf "]\n")
  in
  let rec gen_list accu = function
      0 -> accu
    | n when n>0 ->
	let x = (Random.int 10) in
	gen_list (B_a(x,B_b(string_of_int x,accu))) (n-1)
    | _ -> Printf.fprintf stderr "taille doit etre positif !" ; exit 2
  in
  let usage = "Prog TP: question 4\nquestion4 graine taille" in
    Arg.parse (Arg.align []) anonfun usage ;
    (
      match get_liste () with
	| seed::size::_ ->
	    Random.init seed;
	    let l = A(gen_list Nil_a size) in
	      Printf.printf "l = " ;
	      print_bilist l;
	      Printf.printf "deinterlace l = \n" ;
	      let (l1,l2) = deinterlace l in
		print_int_list l1;
		print_str_list l2;
	    exit 0
	| _ ->
	    Arg.usage (Arg.align []) usage ;
	    exit 1
    )
