(*
 * Test question 5
 *)

open Question5

(* Partie test: ne pas modifier *)
let _ =
  let q = Queue.create () in
  let anonfun s =
    try
      let x = int_of_string s in
	Queue.add x q
    with
	_ -> ()
  in
  let get_liste () =
    List.rev (Queue.fold (fun x y -> y::x) [] q)
  in
  let rec gen_tree off = function
      0 -> Nil
    | taille when taille>0 ->
	Node (gen_tree off (taille/2),
	      {key = taille + off; value= string_of_int (taille + off)},
	      gen_tree (off + taille) (taille/2))
    | _ -> Printf.fprintf stderr "taille doit etre positif !" ; exit 2
  in
  let rec print_tree = function
      Nil -> Format.printf "@,Nil "
    | Node(Nil,b,Nil) ->
	  Format.printf "@,@[<h>Node(Nil,{%i,\"%s\"},Nil)@]" b.key b.value
    | Node(ls,b,rs) ->
	begin
	  Format.printf "@,Node(@[<v>";
	  print_tree ls;
	  Format.printf ",@,@[<h>{%i,\"%s\"}@]," b.key b.value;
	  print_tree rs;
	  Format.printf "@]@,)";
	end
  in
  let usage = "Prog TP: question 5\nquestion5 taille clef" in
    Arg.parse (Arg.align []) anonfun usage ;
    (
      match get_liste () with
	| size::key::_ ->
	    let t = gen_tree 0 size in
	      Format.printf "@[<b>t =" ;
	      print_tree t;
	      Format.printf "@]@.";
	      (try
		 Format.printf "@.@[<b 2>find %i = \"%s\"@]@." key (find key t)
	       with
		   Not_found ->
		     Format.printf "@.@[<b 2>find %i : not in the tree@]@." key
	      );
	    exit 0
	| _ ->
	    Arg.usage (Arg.align []) usage ;
	    exit 1
    )
