(*
 * Test question 7
 *)

open Question7


let print_instr = function
    Nop -> Format.printf "Nop@,"
  | PUSH i -> Format.printf "PUSH %i@," i
  | POPA -> Format.printf "POPA@,"
  | POPB -> Format.printf "POPB@,"
  | PUSHA -> Format.printf "PUSHA@,"
  | PUSHB -> Format.printf "PUSHB@,"
  | ADD -> Format.printf "ADD@,"
  | SUB -> Format.printf "SUB@,"
  | MUL -> Format.printf "MUL@,"
  | JMP s -> Format.printf "JMP %s@," s
  | BEQ(i,s) -> Format.printf "BEQ %i %s@," i s
  | BNZ s -> Format.printf "BNZ %s@," s
  | LAB s -> Format.printf "LAB %s@," s
  | OUT -> Format.printf "OUT@,"
  | STOP -> Format.printf "STOP@,"

(* Partie test: ne pas modifier *)
let _ =
  let q = Queue.create () in
  let anonfun s =
    try
      let x = int_of_string s in
	Queue.add x q
    with
	_ -> ()
  in
  let get_liste () =
    List.rev (Queue.fold (fun x y -> y::x) [] q)
  in
  let newprg n =  [|
    PUSH n;
    PUSH 1;
    POPB;
    LAB "boucle";
    POPA;
    PUSHA;
    PUSHB;
    MUL;
    POPB;
    PUSH 1;
    PUSHA;
    SUB;
    BNZ "boucle";
    PUSHB;
    OUT;
    STOP
  |]
  in
  let usage = "Prog TP: question 7\nquestion7 n" in
    Arg.parse (Arg.align []) anonfun usage ;
    (
      match get_liste () with
	| n::_ ->
	    let prg = newprg n in
	      Format.printf "@[<v 2>prg =@,";
	      Array.iter (print_instr) prg;
	      Format.printf "@]@.eval prg ->@.";
	      eval prg;
	      Format.printf "@.";
	      exit 0
	| _ ->
	    Arg.usage (Arg.align []) usage ;
	    exit 1
    )
